# -*- coding: utf-8 -*-
# viewlets.py
import grok
from grok.interfaces import IContainer
from zope.interface import Interface
from interfaces import IUniversity 

grok.context(Interface)

class Index(grok.View):
    """main structure for all pages"""
    grok.template('master')
    
    def __init__(self, context, request):#
        super(Index, self).__init__(context, request)

class Head(grok.ViewletManager):
    """viewlet manager for the HTML head area"""
    grok.name('head')

class Title(grok.Viewlet):
    """defines html/head/title"""
    grok.viewletmanager(Head)

class AppCSS(grok.Viewlet):
    """loads the default application CSS (static/app.css)"""
    grok.viewletmanager(Head)

class Header(grok.ViewletManager):
    """viewlet manager for the head area of the page"""
    grok.name('header')

class Logo(grok.Viewlet):
    """display the logo"""
    grok.viewletmanager(Header)
    grok.order(1)

class NavigationBar(grok.Viewlet):
    """display the menu bar 
    (at the moment uses objects of the site as menu items)"""
    grok.viewletmanager(Header)
    grok.order(2)
    
    def getSite(self):
        return grok.getSite()

class LeftSidebar(grok.ViewletManager):
    """viewlet manager for the lefthand side bar
    that will contain some essential information 
    about the displayed item"""
    grok.name('left')

class AuthUser(grok.Viewlet):
    """display the current user's name"""
    grok.viewletmanager(LeftSidebar)
    grok.view(Index)
    grok.order(1)

class Login(grok.Viewlet):
    """display an useless login form"""
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(Index)
    grok.order(2)

class MainArea(grok.ViewletManager):
    """viewlet manager for the main content area"""
    grok.name('main')
    #grok.context(IContainer)

class Footer(grok.ViewletManager):
    """viewlet manager for the foot bar"""
    grok.name('footer')

class Copyright(grok.Viewlet):
    """display a copyright notice"""
    grok.viewletmanager(Footer)
